=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class Transaction
    attr_accessor :commercial_invoice_url

    attr_accessor :eta

    attr_accessor :label_url

    attr_accessor :messages

    attr_accessor :metadata

    attr_accessor :object_created

    attr_accessor :object_id

    attr_accessor :object_owner

    attr_accessor :object_state

    attr_accessor :object_updated

    attr_accessor :qr_code_url

    attr_accessor :rate

    attr_accessor :status

    attr_accessor :test

    attr_accessor :tracking_number

    attr_accessor :tracking_status

    attr_accessor :tracking_url_provider

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'commercial_invoice_url' => :'commercial_invoice_url',
        :'eta' => :'eta',
        :'label_url' => :'label_url',
        :'messages' => :'messages',
        :'metadata' => :'metadata',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'object_state' => :'object_state',
        :'object_updated' => :'object_updated',
        :'qr_code_url' => :'qr_code_url',
        :'rate' => :'rate',
        :'status' => :'status',
        :'test' => :'test',
        :'tracking_number' => :'tracking_number',
        :'tracking_status' => :'tracking_status',
        :'tracking_url_provider' => :'tracking_url_provider'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'commercial_invoice_url' => :'Object',
        :'eta' => :'Object',
        :'label_url' => :'Object',
        :'messages' => :'Object',
        :'metadata' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'object_state' => :'Object',
        :'object_updated' => :'Object',
        :'qr_code_url' => :'Object',
        :'rate' => :'Object',
        :'status' => :'Object',
        :'test' => :'Object',
        :'tracking_number' => :'Object',
        :'tracking_status' => :'Object',
        :'tracking_url_provider' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::Transaction` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::Transaction`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'commercial_invoice_url')
        self.commercial_invoice_url = attributes[:'commercial_invoice_url']
      end

      if attributes.key?(:'eta')
        self.eta = attributes[:'eta']
      end

      if attributes.key?(:'label_url')
        self.label_url = attributes[:'label_url']
      end

      if attributes.key?(:'messages')
        if (value = attributes[:'messages']).is_a?(Array)
          self.messages = value
        end
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'object_state')
        self.object_state = attributes[:'object_state']
      end

      if attributes.key?(:'object_updated')
        self.object_updated = attributes[:'object_updated']
      end

      if attributes.key?(:'qr_code_url')
        self.qr_code_url = attributes[:'qr_code_url']
      end

      if attributes.key?(:'rate')
        self.rate = attributes[:'rate']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end

      if attributes.key?(:'tracking_number')
        self.tracking_number = attributes[:'tracking_number']
      end

      if attributes.key?(:'tracking_status')
        self.tracking_status = attributes[:'tracking_status']
      end

      if attributes.key?(:'tracking_url_provider')
        self.tracking_url_provider = attributes[:'tracking_url_provider']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      object_state_validator = EnumAttributeValidator.new('Object', ['VALID', 'INVALID'])
      return false unless object_state_validator.valid?(@object_state)
      status_validator = EnumAttributeValidator.new('Object', ['WAITING', 'QUEUED', 'SUCCESS', 'ERROR', 'REFUNDED', 'REFUNDPENDING', 'REFUNDREJECTED'])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] object_state Object to be assigned
    def object_state=(object_state)
      validator = EnumAttributeValidator.new('Object', ['VALID', 'INVALID'])
      unless validator.valid?(object_state)
        fail ArgumentError, "invalid value for \"object_state\", must be one of #{validator.allowable_values}."
      end
      @object_state = object_state
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('Object', ['WAITING', 'QUEUED', 'SUCCESS', 'ERROR', 'REFUNDED', 'REFUNDPENDING', 'REFUNDREJECTED'])
      unless validator.valid?(status)
        fail ArgumentError, "invalid value for \"status\", must be one of #{validator.allowable_values}."
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          commercial_invoice_url == o.commercial_invoice_url &&
          eta == o.eta &&
          label_url == o.label_url &&
          messages == o.messages &&
          metadata == o.metadata &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          object_state == o.object_state &&
          object_updated == o.object_updated &&
          qr_code_url == o.qr_code_url &&
          rate == o.rate &&
          status == o.status &&
          test == o.test &&
          tracking_number == o.tracking_number &&
          tracking_status == o.tracking_status &&
          tracking_url_provider == o.tracking_url_provider
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [commercial_invoice_url, eta, label_url, messages, metadata, object_created, object_id, object_owner, object_state, object_updated, qr_code_url, rate, status, test, tracking_number, tracking_status, tracking_url_provider].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
